package me.StevenLawson.TotalFreedomMod.Commands;

import java.util.ArrayList;
import java.util.List;

import me.StevenLawson.TotalFreedomMod.TFM_Superadmin;
import me.StevenLawson.TotalFreedomMod.TFM_SuperadminList;
import me.StevenLawson.TotalFreedomMod.TFM_Util;
import org.apache.commons.lang.StringUtils;

import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

@CommandPermissions(level = AdminLevel.ALL, source = SourceType.BOTH)
@CommandParameters(description = "Lists the real names of all online players.", usage = "/<command> [-a]", aliases = "who")
public class Command_list extends TFM_Command
{
    private static enum ListFilter
    {
        ALL,
        ADMINS;
    }

    @Override
    public boolean run(CommandSender sender, Player sender_p, Command cmd, String commandLabel, String[] args, boolean senderIsConsole)
    {
        if (args.length > 1)
        {
            return false;
        }

        if (TFM_Util.isFromHostConsole(sender.getName()))
        {
            final List<String> names = new ArrayList<String>();
            for (Player player : server.getOnlinePlayers())
            {
                names.add(player.getName());
            }
            playerMsg("There are " + names.size() + "/" + server.getMaxPlayers() + " players online:\n" + StringUtils.join(names, ", "), ChatColor.WHITE);
            return true;
        }

        final ListFilter listFilter = (args.length == 1 && args[0].equals("-a") ? ListFilter.ADMINS : ListFilter.ALL);

        final StringBuilder onlineStats = new StringBuilder();
        final StringBuilder onlineUsers = new StringBuilder();

        onlineStats.append(ChatColor.BLUE).append("There are ").append(ChatColor.RED).append(server.getOnlinePlayers().length);
        onlineStats.append(ChatColor.BLUE).append(" out of a maximum ").append(ChatColor.RED).append(server.getMaxPlayers());
        onlineStats.append(ChatColor.BLUE).append(" players online.");

        final List<String> names = new ArrayList<String>();
        for (Player player : server.getOnlinePlayers())
        {
            boolean userSuperadmin = TFM_SuperadminList.isUserSuperadmin(player);

            if (listFilter == ListFilter.ADMINS && !userSuperadmin)
            {
                continue;
            }

            String prefix = "";

            if (userSuperadmin)
            {
                final TFM_Superadmin entry = TFM_SuperadminList.getAdminEntry(player.getName());
                if (entry == null)
                {
                    prefix = ChatColor.GOLD + "[SA]";
                }
                else if (entry.isSeniorAdmin())
                {
                    prefix = ChatColor.LIGHT_PURPLE + "[SrA]";
                }
                else if (entry.isTelnetAdmin())
                {
                    prefix = ChatColor.DARK_GREEN + "[STA]";
                }

                if (TFM_Util.DEVELOPERS.contains(player.getName()))
                {
                    prefix = ChatColor.DARK_PURPLE + "[Dev]";
                }

                if (player.getName().equals("markbyron"))
                {
                    prefix = ChatColor.BLUE + "[Owner]";
                }
            }
            else
            {
                if (player.isOp())
                {
                    prefix = ChatColor.RED + "[OP]";
                }
            }

            names.add(prefix + player.getName() + ChatColor.WHITE);
        }

        onlineUsers.append("Connected ");
        onlineUsers.append(listFilter == ListFilter.ADMINS ? "admins: " : "players: ");
        onlineUsers.append(StringUtils.join(names, ", "));

        if (senderIsConsole)
        {
            sender.sendMessage(ChatColor.stripColor(onlineStats.toString()));
            sender.sendMessage(ChatColor.stripColor(onlineUsers.toString()));
        }
        else
        {
            sender.sendMessage(onlineStats.toString());
            sender.sendMessage(onlineUsers.toString());
        }

        return true;
    }
}
